/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     coded in ECMAScript 5 - JavaScript 5  (ES5, ECMAScript 2009)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


//  xxxxxxxxxxxxxxx   wm10 variable declarations  xxxxxxxxxxxxxxxx

// Note: let and const are not used because of backward compatibility

// These variables below can be directly modified by the user on the options form: 

var rows = 10;   // rox count in one page (screen) => row count

var cols= 10;   // shape count in one row  => column count

var itemCnt = 5;       // total item count (page count on options form)  => itemCnt= parseInt(document.getElementById("items").value, 10);    
 
var rand = false;    // random target frequency generator (Use full random generator for target) 

var pmin = 10;   // Minimum target frequency per page (percent)

var pmax = 20;  // Maximum target frequency per page (percent)

var header = 4;    // rows reserved for target stimulus on header
   
/*  mtype => match type => difference between match (target) stimulus and pattern stimulus 
    "0" == only shape ; "1" == only color;  "2" == shape and color; */
var mtype = "0"; 

var vtype = "1";   // Target stimulus - changing  "0" =>Random between pages; "1" => selected Constant between task; "2" =>Always constant

var emoji = false;   // stimulus generator. if (emoji) => draw E-moji, else draw geometric shapes

var tcolor= true;   //  if (tcolor==true) all colors will be used (full random colors). if (tcolor==false) => only basic html colors are used 

var is_back = true;    // if (is_back==true) => user can go back to previous item (Undo) 

var demo = false;       // if (demo == true) => show correct solution

var timer = 600;     // Task time in seconds if clock = 1000ms (default). 

var timer_enabled = true;   // if true => timer is enabled. if false timer is disabled 

var prg_type = "1";   //  type of information in Progress Bar => default: remaining Time 

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 


// Other wm10 variables and constants:

var clock = 1000;  // basic timer resolution in ms. Default = 1s (1000ms)

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var counter = 0;      // timer counter. if (counter >= time) Timer will call theEnd()   

var item = 0;   // current item      

var r;      // shape radius (square base -width/height)  - x and y raster

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var is_task = false;    // task in progress or not  (for timer)
      
/*  stim = jagged array= [item][shape] =>
[
[0] = x; [1] =y;  [2]= shape type; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected
]*/
var stim = [];  

var stim_b = [];        // canvas (viewport) bounds => stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom

var  match = [];   // match stimulus (target). item x [ 0 == shape type;  1 == color ]

// array values constants for Emoji drawings:
// var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062, 11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806, 127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                 
var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 
           9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062,
           11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806,
           127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 
           128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                     

var s_max= 36;    // maximum shape type [36  or  arr.lenght-1]. Don't change this without changing dependent functions (see source code) 


//  xxxxxxxxxxxxxxx     wm10 functions  xxxxxxxxxxxxxxxx


// init html page [create/start Timer, check storage, show start panel..] 
function init() 
{  
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {wm10Timer()},clock);      
  if (isStorage() && storageAvailable('localStorage'))  {
    document.getElementById("store_group").disabled= false;
  }
  else  {
    document.getElementById("store_msg").textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline).";
    document.getElementById("store_group").disabled= true;  
    document.getElementById("clr_store").disabled= true;     // IE11 bug  => childrens are not auto disabled
    document.getElementById("store").disabled= true;          // IE11 bug => childrens are not auto disabled
  }      
  document.getElementById("pmin_msg").textContent= "Expected min target count= " + Math.round(parseInt(document.getElementById("pmin").value,10) * parseInt(document.getElementById("rows").value,10) * parseInt(document.getElementById("cols").value,10) / 100);            
  document.getElementById("pmax_msg").textContent= "Expected max target count= " + Math.round(parseInt(document.getElementById("pmax").value,10) * parseInt(document.getElementById("rows").value,10) * parseInt(document.getElementById("cols").value,10) / 100);      
  defPage();    
  showStart();
}


// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("table_grp").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               //  localStorage/sessionStorage is supported     
  } 
  else {
    return false;           // no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// show forms with application options (settings)
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").style="text-align:center";  // bug? auto-remove style when element.style.display="none"
  document.getElementById("instructions").style.display ="none";     
  if (document.getElementById("store_group").disabled === false && localStorage.getItem("wm10-v1.0")) 
  {
    var cnt= JSON.parse(localStorage.getItem("wm10-v1.0")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " wm10 results stored in your web browser";
  }
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").style="text-align:center";  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").style="text-align:center";   // bug?
  document.getElementById("instructions").style.display ="block";
  document.getElementById("ins_back").style.display = (is_back) ? "block" : "none";
  document.getElementById("ins_timer").style.display = (document.getElementById("timer_enabled").checked) ? "block" : "none";   
  
  if (mtype === "0")  {   //  Only shape    
    document.getElementById("mtype_0").style.display= "block"; 
    document.getElementById("mtype_1").style.display= "none"; 
    document.getElementById("mtype_2").style.display= "none";               
  }
  else if (mtype === "1")  {  // Only color     
    document.getElementById("mtype_0").style.display= "none"; 
    document.getElementById("mtype_1").style.display= "block"; 
    document.getElementById("mtype_2").style.display= "none";               
  }
  else  {  // Shape and color   
    document.getElementById("mtype_0").style.display= "none"; 
    document.getElementById("mtype_1").style.display= "none"; 
    document.getElementById("mtype_2").style.display= "block";               
  }
  
  refMsg();  
}

       
// refresh variable research Options (update *_msg label) => give user short option HELP
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";    
  
  switch (my_id)
  {
    
    // Items (pages)
    case "rows":     
    case "cols":
      if (e.validity.valid)  {           
        msg.removeAttribute("class");       
        msg.textContent= "";       //msg.textContent=  e.value;
        setFreq(null);  
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");    // msg.className = 'error';
      } 
      refItem();
      cmpWidth();
      break; 
       
    case "items":    
      if (e.validity.valid)  {       
        msg.removeAttribute("class");        
        msg.textContent= "";        //msg.textContent=  e.value; 
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");    // msg.className = 'error';
      }         
      refItem();
      break;
      
    case "rand":
      if (e.checked)  {
        msg.textContent="Yes";
        document.getElementById("pmin").disabled= true;
        document.getElementById("pmax").disabled= true;       
      }
      else  {
        msg.textContent="No";
        document.getElementById("pmin").disabled= false;
        document.getElementById("pmax").disabled= false;
      } 
      setFreq(null);        
      break;      
              
    case "pmin":
    case "pmax": 
      if (e.validity.valid)  {     
        setFreq(my_id);  
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
        msg.setAttribute("class", "error");
      }        
      break;    
      
    case "header":           
      msg.textContent=  (e.value === "0")  ? "A narrow header for target stimulus"  : "A wider header for the target stimulus";         
      cmpWidth();
      break;
                                      
    // Paradigm design        
    case "mtype":            
      if (e.value === "0")  {    // only shape
        msg.textContent= "The target stimulus has a certain geometric shape. The color of all stimuli is irrelevant."; 
        document.getElementById("emoji").value="0";   // shapes
        document.getElementById("emoji").disabled= true;        
        document.getElementById("tcolor").value = "1";    // set auto default value => full random colors mode     
      }
      else if (e.value === "1")  {     // only color
        msg.textContent=  "The target stimulus has a specific color. The geometric shape of all stimuli is irrelevant.";
        document.getElementById("emoji").value="0";    // shapes
        document.getElementById("emoji").disabled= true;
        document.getElementById("tcolor").value = "0";    // set auto default value => basic html colors                  
      }
      else  {       // shape and color
        msg.textContent= "The target stimulus should be distinguished from the non-target stimuli by geometric shape and color. The geometric shape and color of the stimuli are relevant at the same time."; 
        document.getElementById("emoji").disabled= false;
        document.getElementById("tcolor").value = "0";    // set auto default value => basic html colors        
      }        
      break;
      
    case "vtype":     
      if (e.value === "0")  {   
        msg.textContent= "The target stimulus will be randomly generated separately on each page (item)";     
      }
      else if (e.value === "1")  {    
        msg.textContent=  "The target stimulus will be the same during one task (session)";                 
      }
      else  {      
        msg.textContent= "The target stimulus will always be the same";        
      }          
      break;

    case "emoji":     
      if (e.value === "1")  {  
        msg.innerHTML= "Emoji will be displayed  (only for Shape and color). You should see elephant here: " + "&#128024";            
        document.getElementById("tcolor").disabled = false; 
      }             
      else  {            
        msg.textContent="Geometric shapes will be displayed.";       
      }
      break;
                     
    case "tcolor":                                                                                                                                            
      msg.textContent= (e.value === "0") ? "Drawings will be displayed only in basic html colors (mainly recommended)." : "The drawings will be displayed in all possible colors. In some percent of cases it is possible to generate very similar colors that are difficult to distinguish (recommended for 'Only shape').";
      break;
     
    case "is_back":
      msg.textContent= (e.checked) ?  "Yes" : "No";         
      break;
      
    case "demo":    
      if (e.checked)  {
        msg.textContent= " (Yes -The correct answer will have a background in this color and red border)";
        msg.setAttribute("style", "background-color:#FFFFF0;border:1px solid #FF0000;");   // background-color:ivory; border:red
      }
      else  {
        msg.textContent=" (No)";
        msg.removeAttribute("style");
      }    
      break;
  
    // Temporal resolution          
    case "timer":
      if (e.validity.valid)  {
        msg.textContent= stringTime(e.value); 
        msg.removeAttribute("class");
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");
      } 
      break;                
      
    case  "timer_enabled":   
      if (e.checked)  {
        msg.textContent= "Yes";
        document.getElementById("timer").disabled = false;
      }
      else  {  
        msg.textContent= "Timer is disabled";
        document.getElementById("timer").disabled =true; 
      }       
      break;
       
    case "prg_type":                                                                                                                                            
      msg.textContent= (e.value === "0") ? "It will be displayed how many tasks are left to the end" : "The remaining time until the end of the task will be displayed (only if timer is enabled)";
      break;   
      
    // storage 
    case "store":                                                                                                                                            
      msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
      break;  
      
  }   // switch (my_id)
       
}


// update (compute) shape count on options form 
function refItem()  
{
  if ( document.getElementById("rows").validity.valid && document.getElementById("cols").validity.valid && document.getElementById("items").validity.valid )  {
    document.getElementById("shape_cnt").removeAttribute("class");    
    var p= parseInt(document.getElementById("rows").value, 10) * parseInt(document.getElementById("cols").value, 10);
    var t= p * parseInt(document.getElementById("items").value, 10);
    document.getElementById("shape_cnt").textContent= "Shapes in one item (page): " + p +  ". Total number of shapes: " + t;    
  }
  else  {   
    document.getElementById("shape_cnt").setAttribute("class", "error");
    document.getElementById("shape_cnt").textContent= "Total number of shapes: Invalid value";        
  }   
}


// update Minimum and Maximum target frequency per page (percent)
// my_id == element.id or null
function setFreq(my_id)
{  
  if (document.getElementById("rand").checked || document.getElementById("pmin").disabled || document.getElementById("pmax").disabled)
  {
    document.getElementById("pmin_msg").textContent="";
    document.getElementById("pmax_msg").textContent=""; 
    return;
  }   
  if (parseInt(document.getElementById("pmin").value,10) <= parseInt(document.getElementById("pmax").value, 10))  
  {       
    document.getElementById("pmin_msg").removeAttribute("class");                   
    document.getElementById("pmin_msg").textContent= "Expected min target count= " + Math.round(parseInt(document.getElementById("pmin").value,10) * parseInt(document.getElementById("rows").value,10) * parseInt(document.getElementById("cols").value,10) / 100);   
    document.getElementById("pmax_msg").removeAttribute("class");
    document.getElementById("pmax_msg").textContent= "Expected max target count= " + Math.round(parseInt(document.getElementById("pmax").value,10) * parseInt(document.getElementById("rows").value,10) * parseInt(document.getElementById("cols").value,10) / 100);
  }
  else if (my_id) 
  {   
    var msg = document.getElementById(my_id + "_msg");
    msg.textContent= "Maximum target frequency per page must be greater or equal then Minimum target frequency per page"; 
    msg.setAttribute("class", "error");
  }
}


// set default research Page layout (rows and columns count)
function defPage()
{       
  var _rows= 1;  
  var _cols= 1;
  var k= Math.round(window.innerWidth/window.innerHeight);
  var res;   // res == default shape width (width=height) => 2 * window.r
  var row_max= document.getElementById("rows").max;
  var col_max= document.getElementById("cols").max; 
  do  
  {       
    res= getWidth(_rows,_cols, window.header);
    if (res <= 50 || _rows >= row_max || _cols >= col_max) break;
    _rows++;
    _cols+=k;
  }
  while (res > 50);                                                          
  window.rows=_rows;
  window.cols=_cols;
  document.getElementById("rows").value=window.rows;
  document.getElementById("cols").value=window.cols; 
  document.getElementById("shp_demo").style="line-height:" + res + "px";        // vertical-align text middle
  document.getElementById("shp_width").textContent= "Expected shape size (px):" + res;
  document.getElementById("shp_demo").style="display:inline-block;background-color:#ff0000;vertical-align:middle;width:" + res + "px;height:" + res + "px";    
}


// row = row count; col= column count, h == header row count 
// compute shape width (2 x window.r)
function getWidth(r, c, h)  {   
  var dx = Math.floor(0.95 * window.innerWidth/c); 
  var dy = Math.floor(0.95 * (window.innerHeight - 50)/(r + h));    
  return Math.floor(Math.min(dx, dy));   // this is shape width  
}  


// compute (estimate) shape width  (2*window.r) and update html/dom elements 
function cmpWidth()
{ 
  var r= parseInt(document.getElementById("rows").value,10);
  var c= parseInt(document.getElementById("cols").value, 10);  
  var h=parseInt(document.getElementById("header").value,10); // add rows for target stimulus on header   
  var res= getWidth(r, c, h);  // this is shape width (width=height) = 2 * window.r. shape == one stimulus       
  document.getElementById("shp_demo").style="line-height:" + res + "px";        // vertical-align text middle
  document.getElementById("shp_width").textContent= "Expected shape size (px):" + res;
  document.getElementById("shp_demo").style="display:inline-block;background-color:#ff0000;vertical-align:middle;width:" + res + "px;height:" + res + "px";
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 
  if ( optionsValid() )  {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").style="text-align:center;color:#000000"; 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").style= "text-align:center;color:#ff0000;font-weight:bold"; // safari 5.1.7 bug? => this don't work
  } 
}


// check for validity.valid object in all input type="number" (6x)
function optionsValid()  
{     
  var res=  document.getElementById("rows").validity.valid && 
    document.getElementById("cols").validity.valid &&   
    document.getElementById("items").validity.valid  &&          
    document.getElementById("pmin").validity.valid  &&
    document.getElementById("pmax").validity.valid  &&
    document.getElementById("timer").validity.valid;
    if (document.getElementById("rand").checked) {
      return res;
    }
    res = res && (parseInt(document.getElementById("pmin").value,10) <= parseInt(document.getElementById("pmax").value, 10));             
    return res;       // Firefox parser don't execute code ok without res var           
}


// start wm10 Task (start Research) 
function startTask(e)   
{       
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
    var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large itemCnt 
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";            
      
  timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
  document.getElementById("progress").style.display= "block";     
  document.getElementById("progress").setAttribute("style", "width:100%");   
  document.getElementById("time_left").textContent= "";
  if  (document.getElementById("prg_type").value === "1")  {
     document.getElementById("progress").className= "progress-bar progress-bar-danger progress-bar-striped";  // remaining time   
  }
  else  {
     document.getElementById("progress").className="progress-bar progress-bar-info progress-bar-striped";     // items/total
  } 
  document.getElementById("progress").setAttribute("style", "width:0");  // reset progress bar width
  
  counter= 0;       // reset timer counter
  is_task= true;    // finally activate timer
  
  item=0;
  drawStim();     // draw first stimulus     
}


// set application variable parameters
function setVarPar()  
{   
 
  if (document.getElementById("rows").validity.valid) rows= parseInt(document.getElementById("rows").value, 10);    
    
  if (document.getElementById("cols").validity.valid) cols= parseInt(document.getElementById("cols").value, 10);  
  
  if (document.getElementById("items").validity.valid) itemCnt= parseInt(document.getElementById("items").value, 10);        
  
  rand= (document.getElementById("rand").checked) ? true: false;
  
  if (document.getElementById("pmin").validity.valid && document.getElementById("pmax").validity.valid 
    && (parseInt(document.getElementById("pmin").value,10) <= parseInt(document.getElementById("pmax").value, 10) ) )   {  
      pmin= parseInt(document.getElementById("pmin").value, 10); 
      pmax= parseInt(document.getElementById("pmax").value, 10); 
  }
    
  header = parseInt(document.getElementById("header").value,10);    // add rows for target stimulus on header. see setPage(), drawStim()
     
  if (document.getElementById("timer").validity.valid) timer= Math.round(parseInt(document.getElementById("timer").value, 10));  
  
  prg_type= document.getElementById("prg_type").value;   //  type of information displayed on Progress Bar   
  
  // not here. see startTask() => timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
               
  mtype = document.getElementById("mtype").value;      // match type.  change:  [only shape; only color; shape and color]
  
  vtype = document.getElementById("vtype").value; 
  
  emoji = (document.getElementById("emoji").value === "1") ? true : false ;  // stimulus type ("1" => Emoji or "0" => Geometric Shapes) 
                   
  tcolor= (document.getElementById("tcolor").value === "0") ? false: true;  // false => only use 10 basic colors; true => use full random colors palette     
  
  is_back= (document.getElementById("is_back").checked) ? true: false;   // enable Go back (previous item)      
    
  demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct solution
     
  store= ( document.getElementById("store_group").disabled === false && document.getElementById("store").value === "1") ? true : false;
  
  s_max= emoji ? (arr.length-1) : 36; 
    
}


// set internal application research parameters
function setPar()  
{  
          
  stim_b = [];  // bounds for stimulus
  match = [];   // match stimulus (target)
  stim = [];    // [item][shape] => [0] = x; [1] =y;  [2]= shape type; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected 
   
  var shape, col, b=false;
  for (var j= 0; j<itemCnt; j++)   
  {    
    match[j]= [];          
    // vtype == [ "0" => Random between pages; "1" => Constant between task (default); "2" => Always constant ]
    if (b === false || vtype === "0") 
    {
      if (vtype === "2")  {
        shape= 0;         // circle (or emoji watch) if vtype == "2" => Always constant
        col= "#000000";   // black
      }
      else   {                      
        shape= getRndInt(0, s_max);    
        col= tcolor ? getRndColor() : getColor();                
      }            
      b=true;
    }
    match[j]= [shape, col];    // 0 == shape type;  1 == color   
  }
}


// main wm10 stimulus generator function
function stimGenerator()  
{ 
  setPar();      // match stimulus (target) is set here
  
  setPage();
    
  var i= 0;    // ordinal item count [0..itemCnt-1] 
  for (var j=0; j<itemCnt; j++)
  {  
    stim[i]= [];   
    stim[i]= setStim(stim_b[0], stim_b[1], stim_b[2], stim_b[3], i);               
    i++;    // next item
  }  
            
}


/* set canvas (viewport) choices (options) bounds        
   stim_b array =>  [0] = left; [1] = top; [2] = right; [3]= bottom  */                                                                                    
function setPage()  
{ 
  document.getElementById("footer").style.display="block";  
  document.getElementById("footer").height= "50";  // const. see img: backward.png => height and forward.png.height  
  var canvas= document.getElementById("canvas");     
  canvas.left= 0; 
  canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;                                   
  // set window.r => shape radius  
  var dx = Math.floor(0.95 * canvas.width/cols);  
  var dy = Math.floor(0.95 * canvas.height/(rows + header)); 
  r= Math.floor(Math.min(dx, dy)/2);  // this is shape radius. shape == each stimulus  
  var off_x= Math.floor( (canvas.width  - cols * 2*r) / 2 );   // remainder space x => offset x
  var off_y= Math.floor( header * 2*r );   // remainder space y => offset y  
  var _left= off_x;   
  var _top= off_y;
  var _right= canvas.width - off_x;
  var _bottom= canvas.height; 
  stim_b= [_left, _top, _right, _bottom];  //  stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom 
  
  //window.r=Math.round(0.90*window.r);    // leave 10% blank space within rect                                                                                                                          
  if (r < 5)  alert("Your screen resolution is probably not enough to distinguish the drawings that will be displayed.\nPossible solutions:\n  -reduce Row count to a smaller value Currently= " + rows + "\n  -reduce the Column count. Currently= " + cols + "\n  -set Target stimulus - header: Narrow");      
}

   
/* set match and sample coordinates; generate stim-coord (x,y) and default properties (target/non-target, color, shapes type)
 divide screen section into raster equal segments (x-horizontal and y-vertical) 
 return array  stim coordinates =>  array index: [0] = x (left); [1] =y (top);  [2]= shape type;  [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected
 parameters:   stim_b array =>  [0] = _left; [1] = _top; [2] = _right; [3]= _bottom 
               _item = item in range [0..itemCnt-1] */     
function setStim(_left, _top, _right, _bottom, _item) 
{  
  var arr= [];    // function result   
  var x, y=_top, shape, col, sel= {}, pos, cnt, ok, is_match; 
  var max = rows*cols-1;
  if (rand)  {
    var low= 0;    // true random generator
    var high=max; 
  }
  else {
    var low= Math.round(pmin * rows * cols / 100);
    var high = Math.round(pmax * rows * cols / 100); 
  }
  var cnt = getRndInt(low, high); 
  for (var i= 1; i <= cnt; i++)
  {
    do
      pos= getRndInt(0, max);
    while (typeof sel[pos] != "undefined");
    sel[pos]= pos;       
  } 
  pos=0;
  for (var i=1; i<=rows; i++) 
  { // i == screen row == x     
    x=_left;
    for (var j=1; j<=cols; j++)  
    {  // j == screen column == y                                    
      if ( typeof sel[pos] === 'undefined')
      {  // non-target stimulus
        is_match= false;  // target (match) or non-target stimulus   
        do
        { 
          shape= getRndInt(0, s_max);    // get new random shape type
          col= tcolor ? getRndColor() : getColor();     // get new random color            
          //  match[item]= [shape, col] =>   0 == shape type;  1 == color
          if (mtype === "0")   {      // match only shape
            ok= (shape != match[_item][0]);
          } 
          else if (mtype === "1") {  // match only color 
            ok = (col != match[_item][1]);  
          }
          else  {    // match color and shape    
            ok= emoji ? (shape != match[_item][0]) : (shape != match[_item][0] || col != match[_item][1]);  
          }                             
        }  while (!ok);
      }  // non-target stimulus                                    
      else  
      {  // target stimulus => just copy shape type and color from match array               
        is_match=  true;          
        if (mtype === "0")   {      // match only shape
          shape= match[_item][0];    //  match[_item]= [shape, col]; => 0 == shape type;    
          col= tcolor ? getRndColor() : getColor();     // get new random color  
        } 
        else if (mtype === "1") {  // match only color 
           col= match[_item][1];      // 1 == color
           shape= getRndInt(0, s_max);    // get new random shape type  
        }
        else  {    // match color and shape    
          shape= match[_item][0];    //  match[_item]= [shape, col]; => 0 == shape type;
          col= emoji ? "#000000" : match[_item][1];      // 1 == color 
        }                       
      }
      arr.push([x, y, shape, col, is_match, false]);   // array index: [0]=x (left); [1]=y (top); [2]= shape type;  [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected
      pos++;
      x+=2*window.r;  // new shape within row => add x
    } 
    y+=2*window.r;  // new row (add y)
  } 
  return arr;  
}


// sets one of mostly basic html predefined colors
// this is mostly default set of 16 html Basic colors 
function getColor() 
{
  var clr = [    
    '#000000',     /* "black" */   
    '#FF0000',     /* "red"   */
    '#008000',     /* "green" */
    '#0000FF',     /* "blue" */   
    '#FFFF00',     /* "yellow" */     
    '#00FF00',     /* "lime" */     
    '#00FFFF',     /* "cyan" / "aqua" */     
    '#FF00FF',     /* magenta / fuchsia  */  
    '#C0C0C0',     /* "silver" */      
    '#800000',     /* maroon */     
    '#808000',     /* "olive" */  
    '#800080',     /* "purple" */    
    '#008080',     /* teal */      
    '#000080',     /* navy */    
    '#FFC0CB',     /* "pink" */           
    '#FFA500'      /* "orange" */ 
    ];      
  var rnd= getRndInt(0,15);  // array clr limits
  //var rnd=  Math.floor(Math.random()*16);   // 0..15
  return clr[rnd];
}


// get full random colors in hex format
function getRndColor() {
  var letters = '0123456789abcdef';
  var color = '#';
  for (var i=0; i<6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// get random integer from min to max range
function getRndInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}


// application timer handler function
function wm10Timer()  
{      
  if (!is_task || !timer_enabled) return;  // nop, idle        
  counter++;
  if (counter >= timer)  {     // task time is limited
    theEnd();
  }     
  else if (prg_type === "1")  
  {   // "1" => Time. display time on Progress Bar  
    var rest=timer-counter;   // this is remaining time 
    var percent= Math.round(100*rest/timer);    
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= stringTime(rest);    
  }   
} 


// return integer into string hh:mm:ss time format
// input par: total == integer (time in seconds)
function stringTime(total) 
{
  var hh = Math.floor(total/(60*60));         
  var divisor_for_minutes = total % (60 * 60);
  var mm = Math.floor(divisor_for_minutes / 60);       
  var divisor_for_seconds = divisor_for_minutes % 60;
  var ss = Math.ceil(divisor_for_seconds);    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = "0"+hh;}     
  if (mm < 10) {mm = "0"+mm;}
  if (ss < 10) {ss = "0"+ss;} 
  return hh + ":" + mm + ":" + ss;
} 


// goto previous item (stimulus)
function priorAnswer()  
{                         
  if (item > 0)  {
    item--;  
    drawStim();     // draw again previous stimulus
  }         
}


// goto next item (stimulus)
function nextItem()  
{               
  if (item < itemCnt-1)  {         
    item++; 
    drawStim();     // draw next stimulus        
  }
  else  {               
    theEnd();  // end of task  
  }
}


// draw (repaint) stimulus    
function drawStim() 
{    
  var canvas= document.getElementById('canvas');
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas             
             
  // draw border around each choices bounds
  /* ctx.beginPath(); 
  ctx.strokeStyle= "#000000";
  // [0] = left; [1] = top; [2] = right; [3]= bottom
    //  choice_width=  stim_b[2] - stim_b[0];  // right - left
    //  choice_height= stim_b[3] - stim_b[1]; // bottom - top      
  ctx.rect(stim_b[0]-5,  stim_b[1]-5, stim_b[2] - stim_b[0]+10 ,  stim_b[3] - stim_b[1]+10);   // draw border around each choices bounds 
  ctx.stroke(); */ 
    
  // draw match (target) stimulus above stim_b rect
  if (emoji)  {    // stim_b[1]/2-r == half of space between canvas.top and stim_b top border              
    drawEmoji(ctx, canvas.width/2-r,  stim_b[1]/2-r, match[item][0], match[item][1]);   // stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom
  }
  else  {      
    drawShape(ctx, canvas.width/2-r,  stim_b[1]/2-r, match[item][0], match[item][1]);   // stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom    
  }     
  
  for (var s in stim[item])   
  {   // s= shapes within item                                        
      // this section draw square border for each shape/emoji 
    ctx.beginPath();  
    ctx.rect(stim[item][s][0], stim[item][s][1], 2*window.r, 2*window.r);   //  	context.rect(x,y,width,height);
    ctx.strokeStyle=  "#000000"; 
    if (stim[item][s][5] || (demo && stim[item][s][4]) )    // [4]= target or not; [5] == selected or not     
    { // set background color for selected answer or set background color in demo mode for correct answer. you must call before drawShape() handler               
      // Gray90 == selected or Ivory == correct 
      ctx.fillStyle =  stim[item][s][5]  ?  "#E5E5E5" : "#FFFFF0";  // the selected answer takes precedence over the correct answer (background color)                        
      ctx.strokeStyle = "#FF0000";
    }
    else  {
      ctx.fillStyle = "#FFFFFF";
      ctx.strokeStyle = "#000000";
    }  
    ctx.fill();             
    ctx.stroke();         
    if (emoji)  {
      drawEmoji(ctx, stim[item][s][0], stim[item][s][1], stim[item][s][2], stim[item][s][3]);   
    }
    else  {
      drawShape(ctx, stim[item][s][0], stim[item][s][1], stim[item][s][2], stim[item][s][3]);   
    }          
  }                                           
  
  // set footer navigation prior button (left arrow) 
  if (item > 0 && is_back)  {  
    document.getElementById("prior").style.display= "inline"; 
  }
  else  {
    document.getElementById("prior").style.display= "none";   
  } 
  // update "Next item" image on "right arrow" button 
  document.getElementById("next").style.backgroundImage = (item === itemCnt-1)  ?  "url('img/end.png')" : "url('img/forward.png')"; 
  // display (update) item count on Progress Bar (default)  
  if (prg_type === "0" )  {                                                                                                                                                         
    var percent = 100*(itemCnt-(item+1))/itemCnt;  // Math.round();      
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= "Item= " + (item + 1) + " Remaining= " + (itemCnt - item-1);  
  } 

}


/* draw all emoji
   ctx = canvas context
   x = x coord square center,
   y = y coord square center   
   shape = e-moji type  
   col = color (fillSyle and/or strokeStyle) */
function drawEmoji(ctx, x, y, shape, col)
{               
  x+=r;    
  y+=2*r;                                                                   
  // https://developer.mozilla.org/en-US/docs/Web/CSS/font-family   https://www.w3schools.com/cssref/css_websafe_fonts.asp
  ctx.font = Math.round(1.5*r).toString() + "px monospace, Courier";    
  ctx.textBaseline="bottom";       ctx.textAlign = "center";  
  // Firefox, Chrome, Edge, Opera: ignore ctx.fillStyle and  ctx.strokeStyle= col  
  ctx.fillStyle = col;   // fill color => this line must be (only necessary for: IE11, Safari) 
  ctx.strokeStyle= col;  // line color (outer border line color). (only necessary for: IE11, Safari)            
  // why using: "tmp" element? because  Backward compatibility.  why not:  String.fromCodePoint()  ?  see: https://caniuse.com/#search=fromCodePoint
  //ctx.fillText(String.fromCodePoint(arr[shape]), x, y);     // direct decimal to emoji. => don't work in IE11, Opera Mini,..
  document.getElementById("tmp").innerHTML="&#" + arr[shape]; 
  ctx.fillText(document.getElementById("tmp").innerHTML, x, y);     // end of draw point number within each Circle       
  //ctx.strokeStyle= "#000000";  // restore to black  
}


/* shape function dispatcher (handler)
   ctx = canvas context
   x = x coord square center,
   y = y coord square center   
   shape = shape type => this argument is main for call different shapes.js functions  
   col = color (fillSyle and/or strokeStyle)
   shapes.js file must be included in DOM  (wm10.html)
*/ 
function drawShape(ctx, x, y, shape, col)
{
  x+=r;    
  y+=r;
  ctx.fillStyle = col;   // fill color
  ctx.strokeStyle= col;  // line color   
  switch (shape)  
  {
    case 0:   // full circle
    case 1:   // 1/2 circle RIGHT oriented
    case 2:   // 1/2 circle DOWN oriented   
    case 3:   // 1/2 circle LEFT oriented
    case 4:   // 1/2 circle UP oriented 
    case 5:   // 3/4 circle with UP-RIGHT hole
    case 6:   // 3/4 circle with DOWN-RIGHT hole
    case 7:   // 3/4 circle with DOWN-LEFT hole 
    case 8:   // 3/4 circle with UP-LEFT hole                          
     if (shape === 0)  {                        
       circle(ctx, x, y, r, 0, 2*Math.PI, false, col);  // full circle 
     }        
     else if (shape === 1)  {
       circle(ctx, x, y, r, 1.5*Math.PI, 0.5*Math.PI, false, col); // 1/2 circle RIGHT oriented      
     }
     else if (shape === 2)  {
       circle(ctx, x, y, r, 0, Math.PI, false, col); // 1/2 circle DOWN oriented     
     } 
     else if (shape === 3)  {
       circle(ctx, x, y, r, 0.5*Math.PI, 1.5*Math.PI, false, col); // 1/2 circle LEFT oriented     
     } 
     else if (shape === 4)  {
       circle(ctx, x, y, r, Math.PI, 0, false, col);   // 1/2 circle UP oriented     
     }        
     else if (shape === 5)  {
       circle(ctx, x, y, r, 0, 1.5*Math.PI, false, col);   // 3/4 circle with UP-RIGHT hole     
     } 
     else if (shape === 6)  { 
       circle(ctx, x, y, r, 0, 0.5*Math.PI, true, col);   // 3/4 circle with DOWN-RIGHT hole     
     } 
     else if (shape === 7)  { 
       circle(ctx, x, y, r, 0.5*Math.PI, Math.PI, true, col);   // 3/4 circle with DOWN-LEFT hole     
     } 
     else if (shape === 8)  { 
       circle(ctx, x, y, r, 1.5*Math.PI, Math.PI, false, col);   // 3/4 circle with UP-LEFT hole     
     }        
     break;
                
    case 9:   // polygon 3 equal sides
    case 10:  // polygon 4 equal sides   
     (shape === 9) ? polygon(ctx, x, y, r, 3, col):  polygon(ctx, x, y, r, 4, col);       
     break;    
                  
    case 11:  //  xxxxxx
     square(ctx, x, y, r-2, col);  // only for square: window.r must be > 2 for shape selection and demo background fill style  
     break;  //   xxxxxx
             
    case 12:    // longer side (base) down
    case 13:    // longer side (base) up
     (shape === 12) ? trapezoid(ctx, x, y, r, col, true) : trapezoid(ctx, x, y, r, col, false) ;  // base down or up   
     break;
              
    case 14: // rectangle - horizontal line is longer then vertical
    case 15: // rectangle - vertical line is longer then horizontal 
     (shape === 14) ? rectangle(ctx, x, y, r, col, true): rectangle(ctx, x, y, r, col, false);              
     break;
                   
    case 16:
    case 17:
     if (shape === 16) {   // vertical ellipse
      var w= r, h= 2*r; // change this 2 param for PI/2 rotation
     }
     else {   // horizontal ellipse
      var w= 2*r, h= r; // change this 2 param for PI/2 rotation
     }
     ellipse(ctx, x - w / 2.0, y - h / 2.0, w, h, col);       
     break; 
                
    case 18: // cross => classic vertical cross
    case 19: // cross => diagonal cross (x) 
     (shape === 18) ? cross(ctx, x, y, r, col, true): cross(ctx, x, y, r, col, false);       
     break;   
             
    case 20:  //(base == true) => draw down-right rotated paralelogram; 
    case 21: // (base== false) => draw left-down rotated paralelogram
     (shape === 20) ? paralelogram(ctx, x, y, r, col, true): paralelogram(ctx, x, y, r, col, false);    
     break;
                               
    case 22:   // star 4-points
    case 23:   // star 5-points
    case 24:   // star 6-points     
     star(ctx, x, y, shape-18, r/2, r, col);       
     break;
                            
    case 25:  //  vertical UP arrow (0)
    case 26:  //  vertical DOWN arrow (1)
    case 27:  //  horizontal LEFT arrow (2)
    case 28:  //  horizontal RIGHT arrow (3)
     arrow(ctx, x, y, r, col, shape-25);       
     break;
            
    case 29:  
    case 30:
     var a= (shape === 29) ? [r, r, 0, 0] : [0, 0, r, r];    // up rect round radius (31) or down round rect radius (32)
     roundRect(ctx, x-r, y-r, 2*r, 2*r, a, col);    
    break;
       
    case 31:     //  mushroom UP oriented     
    case 32:     //  mushroom RIGHT oriented
    case 33:     //  mushroom DOWN oriented
    case 34:     //  mushroom LEFT orinted 
      mushroom(ctx, x, y, r, col, shape-31);
      break;
               
    case 35:  // polygon 5 equal sides
    case 36:  // polygon 6 equal sides      
      (shape === 35) ?  polygon(ctx, x, y, r, 5, col):  polygon(ctx, x, y, r, 6, col);       
      //break; 
                      
  }   // switch (shape) of
   
}  


// user selected shape on canvas 
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{        
  var x= e.clientX, y= e.clientY; 
  // stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom 
  if (x > stim_b[0] && x < stim_b[2] && y > stim_b[1] && y < stim_b[3])  
  {      
    var row = Math.ceil((y - stim_b[1])/(2*r)) -1;    // always is >= 0
    var col = Math.ceil((x - stim_b[0])/(2*r))- 1;    // always is >= 0
    if ( row <= rows && col < cols)  
    {
      var p = row * cols + col; // shape position within stim[item] array (page)
      var is_correct= stim[item][p][4];          
      if (stim[item][p])
      {   // array index: [0] = x; [1] =y;  [2]= shape type;  [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected
        stim[item][p][5]= (stim[item][p][5] === false) ? true : false;   // toggle (reset) answer if user choose already selected answer
        drawStim(); // repaint => update backgroundColor for (un)selected shapes
      }         
    }     
  }   
}


// end of task (research)
function theEnd()  
{     
  timer_enabled= false; 
  is_task= false;
  document.getElementById("canvas").style.display="none"; // this disable doAnswer() event
  document.getElementById("footer").style.display="none";
  document.getElementById("end").style.display="block";  
  var res=0, err=0, mis=0, tot=0;  // res== correct answers; err= errors, mis= missing values; tot= maximum possible score

  //stim[item][s]  => [ [0] = x; [1] =y;  [2]= shape type; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected  ]
  for (var i in stim)   
  {  // i == item
    for (var s in stim[i])   
    {  // s== shape
      if (stim[i][s][4] && stim[i][s][5]) { 
        res++;   // target and selected
        tot++;
      }
      else if (stim[i][s][4] && !stim[i][s][5] )  {
        mis++;       // target and not selected
        tot++;
      }
      else if (!stim[i][s][4] && stim[i][s][5] )  {
        err++;     // not-target and selected
      }
    }
  }                                                            
  document.getElementById("score").textContent= "Correct= " + res + " Missing= " + mis + " Errors= " + err + " Maximum possible score=" + tot;
  document.getElementById("no_google").textContent="";  
  document.getElementById("chart_title").style.display="none"; 

  try  {
    drawReport(res,err,mis);  
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  } 
  
  try 
  {
    if (store) {
      drawStorage(res,err,mis,tot);  
    }
  }        
  catch (e)  { 
    document.getElementById("table_grp").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
           
}



/* async draw and display table and chart with user results (call google API)..
  (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values  
  res = total correct answers in task (sum)
  err = total errors in task (sum)
  mis = total missing values in task (sum) = Number of target stimuli not detected by the user */
function drawReport(res, err, mis) 
{          
  document.getElementById("google_wrapper").style.display="block";  
  //    xxx  table = Displays the sum of: correct answers, errors, and missing values  xxx 
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Answer type');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Sum');      // sum(correct answers, errors, missing values) = number = frequencies             
  data.addRow ( ["Correct", res] );
  data.addRow ( ["Errors", err] ); 
  data.addRow ( ["Missing", mis] );                                      
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  //    xxxxxx      PIE chart  => data are same   => draw PIE chart and table for correct, errors, missing values   xxxxxx 
  options= {   
   is3D: true, 
   legend: 'none',
   pieSliceText: 'value',
   tooltip: {text:'value'},    
   width: '100%',
   chartArea: {width:'100%'}
  };          //title: 'Correct answers, errors and missing values',   
  elem = document.getElementById("chart");   
  elem.style.display = "block"; 
  new google.visualization.PieChart(elem).draw(data, options);     // Create and draw the visualization.     
  document.getElementById("chart_title").style.display="block";  
}


/*  use window.localStorage in client browser
    res = total correct answers in task (sum)
    err = total errors in task (sum)
    mis = total missing values in task (sum)
    tot= maximum possible score in task  */
function drawStorage(res,err,mis,tot)   
{  
  document.getElementById("table_grp").style.display="block";
  var oldItems = JSON.parse(localStorage.getItem("wm10-v1.0")) || []; 
  var id= oldItems.length+1;   
  // set new "record" 
  var newItem = {
    'id': id,
    'date': new Date(),      
    'correct': res, 
    'errors': err,       
    'missing': mis,   
    'max-score': tot,
    'show-correct' : (demo) ? "Yes": "No",      
    'stimulus-per-Page' : rows*cols,
    'pages': itemCnt,      
    'min-frequency': rand ? "": pmin,
    'max-frequency': rand ? "": pmax,
    'timer-time' : (document.getElementById("timer_enabled").checked) ? document.getElementById("timer").value : "",      
    'match-type' : document.getElementById("mtype").options[document.getElementById("mtype").selectedIndex].textContent,      
    'target-changing' : document.getElementById("vtype").options[document.getElementById("vtype").selectedIndex].textContent,
    'emoji': (mtype === "2" && emoji) ? "Yes" : "No",       
    'full-color' : tcolor,
    'is-back' : is_back ? "Yes": "No"         
  };

  oldItems.push(newItem);

  localStorage.setItem("wm10-v1.0", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table_grp"), oldItems); 
   
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
 
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear wm10 web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("wm10-v1.0")  ?  JSON.parse(localStorage.getItem("wm10-v1.0")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no wm10 data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " wm10 results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved wm10 results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("wm10-v1.0"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
